#! /usr/bin/env python
# -*- coding: ISO-8859-2 -*-

# generate_index.py (27.11. 2003) -- generates 'index.html' from 'drd.txt'

import sys
import re

LT_QUEST = 1
LT_STORY = 2
LT_OTHER = 3

DRD_TXT = "./drd.txt"
INDEX_HTML = "./index.html"

HEADER = """<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"
\"http://www.w3.org/TR/html4/loose.dtd\">
<html lang=\"cs\">
<head>
  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-2\">
  <title>Thorgalovy pbhy</title>
</head>
<body style=\"font-family: sans-serif; background-color: silver;\">
<h1>Thorgalovy pbhy</h1>
<p><small>[&nbsp;<a href=\"thorgal.html\">Thorgalovy vlastnosti</a>&nbsp;]&nbsp;&nbsp;[&nbsp;<a href=\"drd.css\">Soubor styl</a>&nbsp;]&nbsp;&nbsp;[&nbsp;<a href=\"drd.txt\">drd.txt</a>&nbsp;]&nbsp;&nbsp;[&nbsp;<a href=\"generate_index.py\">generate_index.py</a>&nbsp;]</small></p>
<ol type=\"I\">
"""
FOOTER = "</ul>\n</ol>\n</body>\n</html>\n"

for_the_first_time = 1

def main(args):
    try:
        fin = open(DRD_TXT, "r")
        fout = open(INDEX_HTML, "w")
        fout.write(HEADER)
        line = fin.readline()
        while (line != ""):
            html_fragment = process_line(line)
            fout.write(html_fragment)
            line = fin.readline()
        fout.write(FOOTER)
        fout.close()
        fin.close()
    except Exception, err:
        print err;
            
def process_line(line):
    fragment = ""
    (line_type, re_match) = guess_line_type(line)
    if (line_type == LT_QUEST):
        fragment = quest_html_fragment(re_match)
    elif (line_type == LT_STORY):
        fragment = story_html_fragment(re_match)
    else:
        pass
    return fragment

def guess_line_type(line):
    quest_pattern = \
              re.compile("^- - - -\s+([IVXLCDM]+)\.\s+((\w+\s?)+)+\s+- - - -$")
    story_pattern = \
             re.compile("^([\*\+ ])?\s+(.+\.htm)\s+\[(.+)\]\s+--\s+((\w+).*)$")

    match = quest_pattern.search(line)
    if (match):
        return (LT_QUEST, match)
    
    match = story_pattern.search(line)
    if (match):
        return (LT_STORY, match)

    return (LT_OTHER, match)

def quest_html_fragment(re_match):
    # \g<1> quest order
    # \g<2> quest name
    tmp = re_match.expand("</ul>\n<li>\g<2>\n<ul>\n")
    global for_the_first_time
    if (for_the_first_time):
        tmp = tmp[6:]
        for_the_first_time = 0
    return tmp

def story_html_fragment(re_match):
    # \g<1> completed ("*") / uncompleted ("+")
    # \g<2> file_mame
    # \g<3> date
    # \g<4> description
    # \g<5> other ("ostatni") / story (whatever)
    anchor = None
    if (re_match.group(5) == "ostatni"):
        anchor = re_match.expand("<a href=\"ostatni/\g<2>\"><i>\g<2></i></a>")
    else:
        anchor = re_match.expand("<a href=\"pribehy/\g<2>\">\g<2></a>")
    done = None
    if (re_match.group(1) == "*"):
        done = ""
    else:
        done = "NEDOKONENO,"
            
    tmp = re_match.expand("  <li>%s <small>%s \g<3>, \g<4></small></li>\n" \
                          % (anchor, done))
    return tmp

if (__name__ == "__main__"):
    main(sys.argv)
